knplabs/gaufrette

PHP library that provides a filesystem abstraction layer

Installs: 10 132 848

Dependents: 153

Suggesters: 22

Stars: 2 237

Watchers: 81

Forks: 331

Open Issues: 85

v0.8.3 2019-06-06 09:56 UTC

README

Gaufrette provides a filesystem abstraction layer.

Build Status AppVeyor Status Quality Score Packagist Version Total Downloads Software License Join the chat at Gitter

Why use Gaufrette?

Imagine you have to manage a lot of medias in a PHP project. Lets see how to take this situation in your advantage using Gaufrette.

The filesystem abstraction layer permits you to develop your application without the need to know where all those medias will be stored and how.

Another advantage of this is the possibility to update the files location without any impact on the code apart from the definition of your filesystem. In example, if your project grows up very fast and if your server reaches its limits, you can easily move your medias in an Amazon S3 server or any other solution.

Documentation

Read the official Gaufrette documentation.

Metapackages for adapters

Every maintained adapter now have a dedicated metapackage. You can find the list on packagist. We highly recommend you to use them as they contain their own requirements: you don't need to worry about third-party dependencies to install before using Gaufrette anymore.

Symfony integration

Symfony integration is available through KnpLabs/KnpGaufretteBundle.

Maintainers

Here is the list of dedicated maintainer(s) for every adapter not deprecated. If you don't receive any response to your issue or pull request in a timely manner, ping us:

Adapter Referent
AwsS3 @NiR-
AzureBlobStorage @NiR-
DoctrineDbal @pedrotroller, @NicolasNSSM
Flysystem @nicolasmure
Ftp @fabschurt
GoogleCloudStorage @AntoineLelaisant
GridFS @NiR-
InMemory
Local
OpenCloud @NiR-
PhpseclibSftp @fabschurt
Zip

For InMemory, Local and Zip adapters everyone in this list is considered as a maintainer.

Development

Requires the latest versions of :

  • docker-ce
  • docker-compose
  1. Create .env file :
$ make dev

and configure it as you want.

  1. Build the php docker image :
$ make build
  1. Install dependencies :
$ make install-deps
  1. Run tests :
$ make tests

You can also use a different php version, simply set the PHP_VERSION env var to any of these values when calling a make target :

See the docker-compose.yml file for more details.

You'll need to clear the previously installed dependencies when switching from a version to an other, to do so, run :

$ make clear-deps
$ PHP_VERSION=<the_version_you_want_to_use> make build install-deps
  1. Apply Coding Standards

You should check for CS violations by using

$ make php-cs-compare

and fix them with

$ make php-cs-fix

Note

This project does not have any stable release yet but we do not want to break BC now.